﻿<h2>Краткий обзор</h2>

Imageset является средством автоматизированного процесса вывода графических файлов с использованием технологий CSS sprites.
Благодаря объединению графических файлов для сервера получается значительная экономия в размере пересылаемых данных и количестве HTTP соединений. Для клиентской стороны также уменьшается трафик и время загрузки.

Дополнительно, для спрайтов меньше заданного размера производится преобразование DATAURI, что дополнительно уменьшает количество HTTP соедиенений.

<h2>Технология</h2>
Что такое CSS Sprites можно ознакомиться на этом сайте http://www.alistapart.com/articles/sprites

Обычно подготовка CSS Sprites состоит из 3 шагов

<ol>
<li>Создание в графическом редакторе или иным путем карты изображений - результат графический файл формата jpg, gif или png (напр. example.png).</li>

<li>Формирование CSS, предварительно вычислив позиций картинок для смещения. Что-то похожее на
img.sprite-1 {
  background: url(example.png) tranparent no-repeat; width: 16px height: 16px ; background-position: 0px 0px;
}
img.sprite-2 {
  background: url(example.png) tranparent no-repeat; width: 16px height: 16px ; background-position: -16px 0px;
}

Для создания эффекта :hover добавляем:

a:hover img.sprite-1 {
  background: url(example.png) tranparent no-repeat; width: 16px height: 16px ; background-position: 0px -16px;
}
a:hover img.sprite-2 {
  background: url(example.png) tranparent no-repeat width: 16px height: 16px ; background-position: -16px -16px;
}
</li>

<li>Формирование кода HTML
&lt;a href='#'&gt;&lt;img class="sprite-1" src="blank.png" /&gt; &lt;!-- картинка 1 из спрайта --&gt; &lt;/a&gt;
&lt;a href='#'&gt;&lt;img class="sprite-2" src="blank.png" /&gt; &lt;!-- картинка 2 из спрайта --&gt; &lt;/a&gt;
</li>
</ol>

С использованием модуля Imageset упрощаются операции на шаге 2 и 3

<ol>
<li>Аналогично создаем в графическом редакторе карту изображений (imageset), руководствуясь следующими правилами:
<ul>
<li>все картинки в наборе должны иметь фиксированный размер,</li>
<li>набор представлен в виде прямоугольной матрицы X-Y,</li>
<li>размещать картинки в наборе нужно по одной оси координат (в дальнейшем можно будет адресоваться к картинке по ее номеру (от 1 и далее) - индекс картинки),</li>
<li>варианты картинок при различном поведении (:hover, :active и прочее) по другой оси (вариант картинки (от 1 и далее)).</li>
</ul>

Так же карту изображений можно создать на одном из генераторов спрайтов, размещенных на просторах интернет.
</li>
<li>Загружаем готовый imageset (Administer -> Settings -> Imageset -> Selectors) и задаем параметры:
<ul>
 <li><strong>Name(Имя)</strong> - в дальнейшем можно будет ссылаться на картинку по этому имени,</li>
 <li><strong>Size(Размер)</strong> - ширина и высота фиксированной видимой области картинки,</li>
 <li><strong>Orientation(Ориентация)</strong> - соответствующее положение, как разместили картинки в наборе (вертикально или горизонтально).</li>
 <li>Опционально, если спрайт сгенерирован с промежутками между видимыми областями:
<ul> 
  <li><strong>FullSize(Полный размер)</strong> - ширина и высота полной картинки,</li>
  <li><strong>Offset(Смещение)</strong> - смещение по X и Y видимой области.</li>
</ul>  
 </li> 
</ul> 
 
</li>
<li>Задаем селекторами CSS показ необходимых вариантов для различных эффектов (:hover, :acive и прочее) (Administer -> Settings -> Imageset -> Selectors)
</li>
<li>Для вывода картинки в коде делаем вставку php-кода: <strong>theme('imageset', &lt;name&gt;, &lt;index&gt;)</strong>, где 

<ul>
<li><strong>&lt;name&gt;</strong> - имя набора,</li> <li><strong>&lt;index&gt;</strong> - индекс картинки (начиная с 1).</li>
</ul>

</ol>
</li>
Таким образом нет необходимости вручную формировать CSS, вычисляя позиции для каждой картинки, за вас это сделает модуль.
И упрощается вывод необходимой картинки, достаточно знать имя набора и номер картинки в этом наборе 

<h2>Ограничения</h2>
-----------------------------------------------
Картинки в одном наборе должны иметь фиксированный размер и не перекрываться.

